//
//  ViewController.swift
//  BooksStoryboard
//
//  Created by Holger Hinzberg on 06.05.15.
//  Copyright (c) 2015 Holger Hinzberg. All rights reserved.
//

import UIKit

class BookSummaryViewController: UIViewController
{
    @IBOutlet var titleButton: UIButton!
    @IBOutlet var authorButton: UIButton!
    @IBOutlet var yearButton: UIButton!
    @IBOutlet var pagesButton: UIButton!
    var book:Book!
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.book = Book()
        // Die Werte des Buches auf die grafische 
        // Oberfläche übertragen
        self.showBook()
    }
    
    func showBook()
    {
        // Die einzelnen Eigenschaften des Objekts book
        // auf die grafische Oberfläche übertragen
        self.titleButton.setTitle(self.book.title,
            forState:UIControlState.Normal)
        
        self.authorButton.setTitle(self.book.author,
            forState:UIControlState.Normal)
        
        self.yearButton.setTitle("\(self.book.year)",
            forState:UIControlState.Normal)
        
        self.pagesButton.setTitle("\(self.book.pages)",
            forState:UIControlState.Normal)
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    @IBAction func titleButtonTouched(sender: AnyObject)
    {
        // Den Segue mit seinem Identifier aufrufen
        self.performSegueWithIdentifier("titleEditSegue", sender: self)
    }
    
    @IBAction func authorButtonTouched(sender: AnyObject)
    {
    }
    
    @IBAction func yearButtonTouched(sender: AnyObject)
    {
    }
    
    @IBAction func pagesButtonTouched(sender: AnyObject)
    {
    }
    
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?)
    {
        print(segue.identifier)
        
        if segue.identifier == "titleEditSegue"
        {
            // Bei diesem Identifier ist der 
            // destinationViewController vom Typ
            // TitleEditViewController
            
            let editController = segue.destinationViewController as? TitleEditViewController
            if editController != nil
            {
                // Den Buchtitel an die Eigenschaft des
                // View Controllers übergeben
                editController?.bookTitle = self.book.title
                
                // Der Controller übergibt sich selbst
                // als Referenz an die zu öffnende Szene
                editController?.parentController = self
            }
        }
    }
    
    func titleDidChange(newTitle:String)
    {
        // Den neuen Titel dem Buch zuweisen
        self.book.title = newTitle
        self.showBook()
        
        // Den View Controller der zweite Szene
        // wieder ausblenden
        self.navigationController?.popViewControllerAnimated(true)
    }
    
}

